//
// automatically generated by spin2cpp v3.1.2 on Wed Sep 28 21:45:28 2016
// C:\Users\Dave\Desktop\s3_spin\temp\spin2cpp.exe --ccode scribbler_rundemos.spin 
//

// *********************************************
// *  Scribbler Default Program                *
// *  Author: Ben Wirz, Element Products, Inc. *
// *  Copyright (c) 2010 Parallax, Inc.        *  
// *  See end of file for terms of use.        *
// ********************************************* 
//
// The Scribbler comes with a series of a 8 Demonstration
// Programs installed when purchased new.  The programs
// are ordered such that each of the Scribbler's sensing
// capabilities are shown statically followed by an
// interactive demonstration of the sensor's
// capabilities.  The demonstration programs are
// selected by by pushing the Blue Push Switch 1 to 8
// times following power-on or by utilizing the
// finger selection technique.  The 3 user LED's
// sequence with each  switch push to indicate the currently
// selected program.  A new program can be selected at any
// time by pushing the switch - the scribbler does not need
// to be turned off.
//
// 1 Button Push    : Light Sensor Display
// 2 Button Pushes  : Light Follow Program
// 3 Button Pushes  : Obstacle Sensor Display
// 4 Button Pushes  : Obstacle Avoid Program
// 5 Button Pushes  : Line Sensor Display
// 6 Button Pushes  : Line Follow Program
// 7 Button Pushes  : Drawing Program
// 8 Button Pushes  : Ambulance Program  
//
// (See the individual functions and the Scribbler Quick
// Start Guide for additional documentation.)
//
// Power Indicator LED:
//  
// The Blue LED serves as a power-on indicator as
// well as displaying the battery condition.
//
// Solid Blue       : Battery Fully Charged
// Dim Blue         : Battery Partially Charged
// Blinking Blue    : Battery Low / Replace or Recharge
//
// Over Current Condition:
//
// In the case of a motor over current condition due
// to an electrical short circuit, the motor driver
// will be disabled in hardware.  This condition is
// indicated by all three of the Red LED's Blinking
// and the Blue LED being turned off.  To reset the
// condition, cycle the Scribblers's power off for 15 seconds
// and then back on.
//
// Scribbler Test Utility:
//
// A Serial Terminal Test Utility has been included with
// the default program for testing the Scribbler.  The utility
// includes a factory test and several debugging
// programs.  The utility was designed to be used with
// a host PC running the Parallax Serial Terminal program.
//
// Parallax Serial Terminal Program Setup
//
// Com Port:  Choose the correct port for the Scribbler
// Baud Rate:  19,200bps
// Click Restore Defaults in the Preferences Window 
// The DTR, RTS & Echo On Boxes should be unchecked
// 
// With the Parallax Serial Terminal enabled on the
// host PC, hold down the blue button while turning on
// the Scribbler's power switch to start the utility.  To exit
// the Test Utility, cycle the Scribbler's power switch.
#include <propeller.h>
#include "scribbler_rundemos.h"

#ifdef __GNUC__
#define INLINE__ static inline
#else
#define INLINE__ static
#define waitcnt(n) _waitcnt(n)
#define coginit(id, code, par) _coginit((unsigned)(par)>>2, (unsigned)(code)>>2, id)
#define cognew(code, par) coginit(0x8, (code), (par))
#define cogstop(i) _cogstop(i)
#endif

INLINE__ int32_t Min__(int32_t a, int32_t b) { return a < b ? a : b; }
INLINE__ int32_t Max__(int32_t a, int32_t b) { return a > b ? a : b; }
INLINE__ int32_t Shr__(uint32_t a, uint32_t b) { return (a>>b); }
INLINE__ int32_t Lookup__(int32_t x, int32_t b, int32_t a[], int32_t n) { int32_t i = (x)-(b); return ((unsigned)i >= n) ? 0 : (a)[i]; }

static  void scribbler_rundemos_set_state(scribbler_rundemos *self, int32_t state_set);
static  int32_t scribbler_rundemos_state_new(scribbler_rundemos *self);
static  void scribbler_rundemos_periodic_init(scribbler_rundemos *self);
static  void scribbler_rundemos_periodic(scribbler_rundemos *self);

void main()
{
  scribbler_rundemos main_self;
  scribbler_rundemos *self = &main_self;
  int32_t	demo_select;
  // Scribbler Demo Start-up & Program Selection
  // Check if the button was held at power on                     
  DIRA &= (~(1 << BUTTON));
  // ifnot INA[scribbler#BUTTON]   'Start the factory test program
  //  scribbler_test.start(VERSION,SUBVERSION,LINE_TRIP_ALT,OBS_THLD) 
  // Start hardware driver cogs and low level routines
  scribbler_start(&self->scribbler);
  scribbler_start_motors();
  scribbler_start_tones(&self->scribbler);
  scribbler_button_mode(-1, -1);
  // Initialize variables
  self->battery_min = 255;
  self->state_current = 0;
  self->state_previous = 0;
  self->state_changed = 0;
  // Branch to a demo program based on either the number of button presses
  // or the user selected finger code following 1 button press.
  if (scribbler_reset_button_count() <= 1) {
    demo_select = scribbler_rundemos_finger_select(self);
  } else {
    demo_select = scribbler_reset_button_count() - 1;
  }
  if (demo_select == 0) {
  scribbler_rundemos_light_sensor(self);
  } else if (demo_select == 1) {
  scribbler_rundemos_light_follow(self);
  } else if (demo_select == 2) {
  scribbler_rundemos_obs_sensor(self);
  } else if (demo_select == 3) {
  scribbler_rundemos_obs_avoid(self, 0);
  } else if (demo_select == 4) {
  scribbler_rundemos_line_sensor(self);
  } else if (demo_select == 5) {
  scribbler_rundemos_line_follow(self);
  } else if (demo_select == 6) {
  scribbler_rundemos_scribble(self);
  } else if (demo_select == 7) {
  scribbler_rundemos_obs_avoid(self, -1);
  }
}

int32_t scribbler_rundemos_finger_select(scribbler_rundemos *self)
{
  int32_t	code, light_trip_left, light_trip_center, light_trip_right, _idx__0005;
  // Capture the finger selected code
  //
  // Returns a 3 bit binary code corresponding to the finger selection
  // The user must hold their fingers over the light sensors holes prior to
  // calling the function.   The fingers should be removed following the
  // the musical note.
  scribbler_delay_tenths(&self->scribbler, 4);
  // Sample and scale light sensor levels at boot (fingers on)
  light_trip_left = (scribbler_light_sensor(LEFT) * LGT_ON_MULT) / LGT_ON_DIV;
  light_trip_center = (scribbler_light_sensor(CENTER) * LGT_ON_MULT) / LGT_ON_DIV;
  light_trip_right = (scribbler_light_sensor(RIGHT) * LGT_ON_MULT) / LGT_ON_DIV;
  // Beep for the user to take fingers off
  scribbler_music_play_note(&self->music, HALF, G3, 0);
  for(_idx__0005 = 0; _idx__0005 < 20; _idx__0005++) {
    // Check for finger removal
    // Time out if not detected
    scribbler_delay_tenths(&self->scribbler, 1);
    if (((light_trip_left < scribbler_light_sensor(LEFT)) || (light_trip_center < scribbler_light_sensor(CENTER))) || (light_trip_right < scribbler_light_sensor(RIGHT))) {
      break;
    }
  }
  // Pause while fingers are removed
  scribbler_delay_tenths(&self->scribbler, 10);
  if (light_trip_right < scribbler_light_sensor(RIGHT)) {
    // Decode the finger bits
    code = 1;
  } else {
    code = 0;
  }
  if (light_trip_center < scribbler_light_sensor(CENTER)) {
    code |= 0x2;
  }
  if (light_trip_left < scribbler_light_sensor(LEFT)) {
    code |= 0x4;
  }
  return code;
}

void scribbler_rundemos_light_sensor(scribbler_rundemos *self)
{
  int32_t	light_init, side;
  // Light Sensor Test Program
  // Finger Code 000 / 0 Button Presses
  //
  // Display light sensor levels on the corresponding left, center and right LED's
  // If a light sensors hole is covered set the LED to off.
  // If the hole is uncovered, the LED will be green or yellow.
  // Trip points are calculated based on the start-up light level - assumes fingers are off
  light_init = Max__((((scribbler_light_sensor(LEFT) + scribbler_light_sensor(CENTER)) + scribbler_light_sensor(RIGHT)) / 3), 40);
  // Pause for 3 seconds before
  scribbler_delay_tenths(&self->scribbler, 30);
  if (SONG_ENABLE) {
    // starting the light program
    scribbler_music_play_song(&self->music, LIGHT, 2000);
  }
  scribbler_rundemos_periodic_init(self);
  while (1) {
    for(side = LEFT; side <= CENTER; side++) {
      if (scribbler_light_sensor(side) >= ((light_init * 90) / 100)) {
        // Trip at 90% of start-up level
        scribbler_set_led(side, GREEN);
      } else {
        if (scribbler_light_sensor(side) >= ((light_init * 80) / 100)) {
          // Trip at 80% of start-up level
          scribbler_set_led(side, YELLOW);
        } else {
          scribbler_set_led(side, OFF);
        }
      }
    }
    scribbler_rundemos_periodic(self);
  }
}

void scribbler_rundemos_light_follow(scribbler_rundemos *self)
{
  int32_t	lost_cnt;
  // Initially disable lost detection
  lost_cnt = 0xfffffe20;
  if (SONG_ENABLE) {
    scribbler_music_play_song(&self->music, REVEILLE, 1000);
  }
  scribbler_rundemos_set_state(self, LGT_CLEAR);
  scribbler_rundemos_set_state(self, LGT_CLEAR);
  scribbler_rundemos_periodic_init(self);
  while (1) {
    if (self->state_current == LGT_CLEAR) {
    // Check Obstacle & Stall Detectors
    if ((scribbler_stalled()) && (STALL_CHECK)) {
      scribbler_rundemos_set_state(self, LGT_STALL);
    } else {
      if ((scribbler_rundemos_obs_sampled(self, LEFT)) && (OBSTACLE_CHECK)) {
        if (self->light_last_detect == LEFT) {
          // Ignore the obstacle and rotate  
          // towards a light if detected on
          scribbler_rundemos_set_state(self, LGT_OBS_OVERIDE_LEFT);
        } else {
          // the obstacle side.
          scribbler_rundemos_set_state(self, LGT_OBS_LEFT);
        }
      } else {
        if ((scribbler_rundemos_obs_sampled(self, RIGHT)) && (OBSTACLE_CHECK)) {
          if (self->light_last_detect == RIGHT) {
            scribbler_rundemos_set_state(self, LGT_OBS_OVERIDE_RIGHT);
          } else {
            scribbler_rundemos_set_state(self, LGT_OBS_RIGHT);
          }
        } else {
          // No stall & no obstacle detected                                                                           
          if (scribbler_rundemos_light_max_check(self) == LEFT) {
          scribbler_set_leds(GREEN, OFF, OFF, NO_CHANGE);
          scribbler_wheels_now(LGT_ARC_SLOW_VEL, LGT_ARC_FAST_VEL, LGT_ARC_TIME);
          lost_cnt = 0;
          } else if (scribbler_rundemos_light_max_check(self) == CENTER) {
          scribbler_set_leds(OFF, GREEN, OFF, NO_CHANGE);
          scribbler_wheels_now(LGT_FOR_VEL, LGT_FOR_VEL, LGT_FOR_TIME);
          lost_cnt = 0;
          } else if (scribbler_rundemos_light_max_check(self) == RIGHT) {
          scribbler_set_leds(OFF, OFF, GREEN, NO_CHANGE);
          scribbler_wheels_now(LGT_ARC_FAST_VEL, LGT_ARC_SLOW_VEL, LGT_ARC_TIME);
          lost_cnt = 0;
          } else if (scribbler_rundemos_light_max_check(self) == NONE) {
          lost_cnt = lost_cnt + 1;
          if (scribbler_moving()) {
            // Set LED on last detected side
            if (lost_cnt == 0x4) {
              scribbler_set_led(self->light_last_detect, YELLOW);
            }
          } else {
            scribbler_set_leds(OFF, OFF, OFF, NO_CHANGE);
            if (lost_cnt == 0xa0) {
              scribbler_music_play_song(&self->music, LOST, 1000);
              lost_cnt = 0;
            }
          }
          }
        }
      }
    }
    } else if (self->state_current == LGT_STALL) {
    // Stall detected
    scribbler_music_play_note(&self->music, QURT, A5, 0);
    // Reverse for half the scribbler's length
    scribbler_move_now((-160), (-160), 2000, 12, 0);
    if (self->light_last_detect == LEFT) {
      // Rotate in last detected
      // light direction.
      scribbler_turn_deg(90);
    } else {
      scribbler_turn_deg((-90));
    }
    scribbler_set_leds(OFF, RED, OFF, NO_CHANGE);
    scribbler_rundemos_set_state(self, LGT_STALL_RECOVER);
    } else if (self->state_current == LGT_STALL_RECOVER) {
    if ((!(scribbler_moving())) && (!(scribbler_stalled()))) {
      scribbler_set_leds(OFF, OFF, OFF, NO_CHANGE);
      scribbler_rundemos_set_state(self, LGT_CLEAR);
    }
    } else if (self->state_current == LGT_OBS_LEFT) {
    // Obstacle Detected                   
    scribbler_set_speed(13);
    // Turn to Avoid  
    scribbler_turn_deg_now((-15));
    scribbler_set_leds(RED, OFF, OFF, NO_CHANGE);
    scribbler_rundemos_set_state(self, LGT_OBS_RECOVER);
    } else if (self->state_current == LGT_OBS_OVERIDE_LEFT) {
    scribbler_set_speed(13);
    scribbler_turn_deg_now(30);
    scribbler_set_leds(ALT_RED_GREEN, OFF, OFF, NO_CHANGE);
    scribbler_rundemos_set_state(self, LGT_OBS_RECOVER);
    } else if (self->state_current == LGT_OBS_RIGHT) {
    scribbler_set_speed(13);
    scribbler_turn_deg_now(15);
    scribbler_set_leds(OFF, OFF, RED, NO_CHANGE);
    scribbler_rundemos_set_state(self, LGT_OBS_RECOVER);
    } else if (self->state_current == LGT_OBS_OVERIDE_RIGHT) {
    scribbler_set_speed(13);
    scribbler_turn_deg_now((-30));
    scribbler_set_leds(OFF, OFF, ALT_RED_GREEN, NO_CHANGE);
    scribbler_rundemos_set_state(self, LGT_OBS_RECOVER);
    } else if (self->state_current == LGT_OBS_RECOVER) {
    if (scribbler_stalled()) {
      scribbler_rundemos_set_state(self, LGT_STALL);
    } else {
      if ((scribbler_rundemos_obs_sampled(self, LEFT)) || (scribbler_rundemos_obs_sampled(self, RIGHT))) {
        // Obstacle still detected -                                     
        scribbler_rundemos_set_state(self, self->state_previous);
      } else {
        if (!(scribbler_moving())) {
          // rotate further   
          scribbler_set_leds(OFF, NO_CHANGE, OFF, NO_CHANGE);
          scribbler_rundemos_set_state(self, LGT_CLEAR);
        }
      }
    }
    }
    scribbler_rundemos_periodic(self);
  }
}

int32_t scribbler_rundemos_light_max_check(scribbler_rundemos *self)
{
  int32_t	sample_left, sample_center, sample_right;
  // Check the three light sensors
  //
  // Return an index to the highest level sensor if the sensor's
  // level is greater than the running average plus a minimum detection level.
  sample_left = scribbler_light_sensor(LEFT);
  sample_center = scribbler_light_sensor(CENTER);
  sample_right = scribbler_light_sensor(RIGHT);
  if (self->light_last == LEFT) {
  self->light_running_avg = (((sample_center + sample_right) / 2) + self->light_running_avg) / 2;
  } else if (self->light_last == CENTER) {
  self->light_running_avg = (((sample_left + sample_right) / 2) + self->light_running_avg) / 2;
  } else if (self->light_last == RIGHT) {
  self->light_running_avg = (((sample_left + sample_center) / 2) + self->light_running_avg) / 2;
  } else if (self->light_last == NONE) {
  self->light_running_avg = ((((sample_left + sample_center) + sample_right) / 3) + self->light_running_avg) / 2;
  }
  if (((sample_left > (self->light_running_avg + LIGHT_TRIP_INC)) && (sample_left > sample_center)) && (sample_left > sample_right)) {
    return (self->light_last = self->light_last_detect = LEFT);
  } else {
    if ((sample_center > (self->light_running_avg + LIGHT_TRIP_INC)) && (sample_center > sample_right)) {
      return (self->light_last = self->light_last_detect = CENTER);
    } else {
      if (sample_right > (self->light_running_avg + LIGHT_TRIP_INC)) {
        return (self->light_last = self->light_last_detect = RIGHT);
      } else {
        return (self->light_last = NONE);
      }
    }
  }
}

void scribbler_rundemos_obs_sensor(scribbler_rundemos *self)
{
  // Obstacle Sensor Test Program
  // Finger Code 0X0 / 3 Button Presses  
  //
  // Display the obstacle sensor state on the left and right LED's.
  // Play a note a note on detection.
  scribbler_set_voices(SIN, SIN);
  scribbler_set_volume(90);
  scribbler_rundemos_periodic_init(self);
  while (1) {
    if ((self->obs_sample_right) && (self->obs_sample_left)) {
      scribbler_play_tone(OBS_DEBUG_NOTE_LENGTH, scribbler_music_freq(E4), 0);
      scribbler_command_tone(PLAY);
      scribbler_set_led(RIGHT, GREEN);
      scribbler_set_led(LEFT, GREEN);
    } else {
      if (self->obs_sample_right) {
        scribbler_play_tone(OBS_DEBUG_NOTE_LENGTH, scribbler_music_freq(B4), 0);
        scribbler_command_tone(PLAY);
        scribbler_set_led(RIGHT, GREEN);
        scribbler_set_led(LEFT, RED);
      } else {
        if (self->obs_sample_left) {
          scribbler_play_tone(OBS_DEBUG_NOTE_LENGTH, scribbler_music_freq(C4), 0);
          scribbler_command_tone(PLAY);
          scribbler_set_led(RIGHT, RED);
          scribbler_set_led(LEFT, GREEN);
        } else {
          scribbler_set_led(RIGHT, RED);
          scribbler_set_led(LEFT, RED);
          scribbler_command_tone(STOP);
        }
      }
    }
    scribbler_rundemos_periodic(self);
  }
}

void scribbler_rundemos_obs_avoid(scribbler_rundemos *self, int32_t ambulance)
{
  int32_t	obs_last, random, sample, sample_last, counter;
  static int32_t look__0001[] = {OFF, RED, OFF, GREEN, };
  static int32_t look__0002[] = {OFF, RED, OFF, GREEN, };
  static int32_t look__0003[] = {OFF, OFF, GREEN, GREEN, OFF, OFF, RED, RED, OFF, OFF, GREEN, RED, OFF, OFF, RED, GREEN, };

  // Obstacle Avoid & Ambulance Behavior
  // Finger Code 0XX / 4 Button Presses - Obstacle Avoid 
  // Finger Code XXX / 8 Button Presses - Ambulance
  //  
  // The scribbler drives randomly while executing the obstacle avoid behaviour.
  // If it senses an obstacle with its IR sensors, it turns in place until
  // the obstacle is no longer in its path.  The scribbler also responds to stall
  // detects by backing up and rotating away from the stall.                                                              
  //
  // Obstacle Avoid LED Codes:
  //
  // Left Red or Right Red - Obstacle Detect 
  // Center Red - Stall Detect
  // Center Green  - Drive Straight Forward
  // Left or Right Yellow - Arc Forward
  //
  // Ambulance Mode:
  //
  // If ambulance is set TRUE, the LED's squence in the pattern simliar
  // to an ambulance light bar and an ambulance siren is played.   
  counter = 0;
  if (SONG_ENABLE) {
    if (ambulance) {
      scribbler_music_play_song(&self->music, AMBULANCE, 2000);
    } else {
      scribbler_music_play_song(&self->music, OBSTACLE, 2000);
    }
  }
  scribbler_rundemos_set_state(self, OBS_STRAIGHT);
  scribbler_rundemos_set_state(self, OBS_STRAIGHT);
  scribbler_rundemos_periodic_init(self);
  while (1) {
    if (self->state_current == OBS_STRAIGHT) {
    if (scribbler_rundemos_obs_sensor_clear(self)) {
      if (scribbler_rundemos_state_new(self)) {
        scribbler_set_speed(OBS_FOR_VEL);
        // Drive straight for a while
        scribbler_go_forward(8000);
      } else {
        if (scribbler_move_ready()) {
          if (!(ambulance)) {
            scribbler_set_leds(OFF, GREEN, OFF, NO_CHANGE);
          }
          scribbler_rundemos_set_state(self, OBS_ROT_RANDOM);
        }
      }
    }
    } else if (self->state_current == OBS_ROT_RANDOM) {
    if (scribbler_rundemos_obs_sensor_clear(self)) {
      if (scribbler_rundemos_state_new(self)) {
        scribbler_set_speed(OBS_ROT_VEL);
        if (scribbler_light_sensor(CENTER) & 0x1) {
          // Choose a random rotate          
          // direction at the end of
          scribbler_turn_deg(45);
        } else {
          // a straight move.
          scribbler_turn_deg((-45));
        }
      } else {
        if (scribbler_move_ready()) {
          if (!(ambulance)) {
            scribbler_set_leds(OFF, YELLOW, OFF, NO_CHANGE);
          }
          scribbler_rundemos_set_state(self, OBS_STRAIGHT);
        }
      }
    }
    } else if (self->state_current == OBS_ARC_LEFT) {
    if (scribbler_rundemos_obs_sensor_clear(self)) {
      if (scribbler_rundemos_state_new(self)) {
        // Arc to the left
        scribbler_set_speed(OBS_FOR_VEL);
        scribbler_arc_deg_now(20, 400);
      } else {
        if (scribbler_move_ready()) {
          if (!(ambulance)) {
            scribbler_set_leds(YELLOW, OFF, OFF, NO_CHANGE);
          }
          scribbler_rundemos_set_state(self, OBS_STRAIGHT);
        }
      }
    }
    } else if (self->state_current == OBS_ARC_RIGHT) {
    // Arc to the right
    if (scribbler_rundemos_obs_sensor_clear(self)) {
      if (scribbler_rundemos_state_new(self)) {
        scribbler_set_speed(OBS_FOR_VEL);
        scribbler_arc_deg_now((-20), (-400));
      } else {
        if (scribbler_move_ready()) {
          if (!(ambulance)) {
            scribbler_set_leds(OFF, OFF, YELLOW, NO_CHANGE);
          }
          scribbler_rundemos_set_state(self, OBS_STRAIGHT);
        }
      }
    }
    } else if (self->state_current == OBS_STALL) {
    if (!(ambulance)) {
      // Stall detected
      scribbler_music_play_note(&self->music, QURT, A5, 0);
    }
    // Reverse for half the scribbler's length
    scribbler_move_now((-160), (-160), 2000, OBS_ROT_VEL, 0);
    if (obs_last == LEFT) {
      // Rotate away from last detected
      // obstacle.
      scribbler_turn_deg((-120));
    } else {
      scribbler_turn_deg(120);
    }
    if (!(ambulance)) {
      scribbler_set_leds(OFF, RED, OFF, NO_CHANGE);
    }
    scribbler_rundemos_set_state(self, OBS_STALL_RECOVER);
    } else if (self->state_current == OBS_STALL_RECOVER) {
    if ((!(scribbler_moving())) && (!(scribbler_stalled()))) {
      if (!(ambulance)) {
        scribbler_set_leds(OFF, OFF, OFF, NO_CHANGE);
      }
      scribbler_rundemos_set_state(self, OBS_STRAIGHT);
    }
    } else if (self->state_current == OBS_DETECT_LEFT) {
    // Obstacle detected                   
    scribbler_set_speed(OBS_ROT_VEL);
    // Turn to avoid  
    scribbler_turn_deg_now((-10));
    if (!(ambulance)) {
      scribbler_set_leds(RED, OFF, OFF, NO_CHANGE);
    }
    scribbler_rundemos_set_state(self, OBS_DETECT_RECOVER);
    obs_last = LEFT;
    } else if (self->state_current == OBS_DETECT_RIGHT) {
    scribbler_set_speed(OBS_ROT_VEL);
    scribbler_turn_deg_now(10);
    if (!(ambulance)) {
      scribbler_set_leds(OFF, OFF, RED, NO_CHANGE);
    }
    scribbler_rundemos_set_state(self, OBS_DETECT_RECOVER);
    obs_last = RIGHT;
    } else if (self->state_current == OBS_DETECT_RECOVER) {
    if (scribbler_stalled()) {
      scribbler_rundemos_set_state(self, OBS_STALL);
    } else {
      if ((scribbler_rundemos_obs_sampled(self, LEFT)) || (scribbler_rundemos_obs_sampled(self, RIGHT))) {
        // Obstacle still detected -                                     
        scribbler_rundemos_set_state(self, self->state_previous);
      } else {
        // rotate further
        if (self->state_previous == OBS_DETECT_RIGHT) {
          // Arc away from last obstacle
          scribbler_rundemos_set_state(self, OBS_ARC_LEFT);
        } else {
          scribbler_rundemos_set_state(self, OBS_ARC_RIGHT);
        }
      }
    }
    }
    if (ambulance) {
      if ((SONG_ENABLE) && (scribbler_get_sync() == 128)) {
        scribbler_music_play_song(&self->music, AMBULANCE, 2000);
      }
      scribbler_set_led(LEFT, Lookup__(((Shr__(counter, 1)) & 0x3), 0, look__0001, 4));
      scribbler_set_led(RIGHT, Lookup__(((Shr__(counter, 1)) & 0x3), 0, look__0002, 4));
      /* 
              
       */
      scribbler_set_led(CENTER, Lookup__((counter & 0x7), 0, look__0003, 16));
    }
    counter = counter + 1;
    scribbler_rundemos_periodic(self);
  }
}

int32_t scribbler_rundemos_obs_sensor_clear(scribbler_rundemos *self)
{
  // Check the obstacle & stall sensors
  //
  // Return TRUE if no obstacles or stalls
  // Return FALSE and change obstacle avoid state otherwise.
  if ((scribbler_stalled()) && (STALL_CHECK)) {
    scribbler_rundemos_set_state(self, OBS_STALL);
    return 0;
  } else {
    if ((scribbler_rundemos_obs_sampled(self, LEFT)) && (OBSTACLE_CHECK)) {
      scribbler_rundemos_set_state(self, OBS_DETECT_LEFT);
      return 0;
    } else {
      if ((scribbler_rundemos_obs_sampled(self, RIGHT)) && (OBSTACLE_CHECK)) {
        scribbler_rundemos_set_state(self, OBS_DETECT_RIGHT);
        return 0;
      } else {
        return -1;
      }
    }
  }
}

int32_t scribbler_rundemos_lift_wait(scribbler_rundemos *self)
{
  int32_t	idler_trip, loop_cnt;
  int32_t result = 0;
  // Wait until the scribbler is placed on the floor or line following track.
  // Set the middle LED blinking green and return TRUE if the user spins
  // the Idler Wheel.  Times out after if floor isn't detected and returns
  scribbler_set_led(CENTER, OFF);
  // Set the idler counter trip point
  idler_trip = scribbler_get_results(CNT_IDLER) + LIFT_SPIN_CNT;
  loop_cnt = 0;
  scribbler_rundemos_periodic_init(self);
  while (1) {
    // Check if idler wheel has been rotated and set the center LED.
    if ((result = -(scribbler_get_results(CNT_IDLER) >= idler_trip))) {
      scribbler_set_led(CENTER, BLINK_GREEN);
    }
    // Check if the scribbler is on the floor 
    if ((((scribbler_line_sensor(LEFT, (-1)) > LINE_LIFT) && (scribbler_line_sensor(RIGHT, (-1)) > LINE_LIFT)) && ((loop_cnt > LIFT_TIME_MIN) || (result))) || (loop_cnt >= LIFT_TIME_MAX)) {
      return result;
    }
    loop_cnt = loop_cnt + 1;
    scribbler_rundemos_periodic(self);
  }
  return result;
}

void scribbler_rundemos_line_sensor(scribbler_rundemos *self)
{
  int32_t	sample_right, sample_left, black_trip;
  // Finger Code X00 / 5 Button Presses  
  // 
  // Display the line sensor's state. The right and left LED's will light
  // green if a line is detected and red if no line is detected.
  //
  // The sensitivity of the line sensors can be modfied if the scribbler has trouble
  // detecing a particular line.  To reduce the sensitivity, hold the scribbler in
  // air while starting the demo with the finger selection method or by
  // pressing the blue switch 5 times. Spin the small rear idler wheel 
  // until the center LED blinks green. Next place the scribbler on the track.
  // Once the track is detected, the scribbler will display the line sensor
  // state as described above.  It is only necessary to to spin the idler
  // wheel if the scribbler has trouble detecting a particular line.  The default
  // setting should work in most cases. 
  if (SONG_ENABLE) {
    scribbler_music_play_song(&self->music, LINESENS, 2000);
  }
  scribbler_set_leds(RED, OFF, RED, NO_CHANGE);
  // Wait for the user to put the scribbler on the track before starting
  if (scribbler_rundemos_lift_wait(self)) {
    black_trip = LINE_TRIP_ALT;
  } else {
    black_trip = LINE_TRIP;
  }
  scribbler_set_led(CENTER, OFF);
  scribbler_rundemos_periodic_init(self);
  while (1) {
    // Sample the line sensors
    sample_left = scribbler_line_sensor(LEFT, (-1));
    sample_right = scribbler_line_sensor(RIGHT, (-1));
    if ((sample_left > LINE_LIFT) && (sample_left <= black_trip)) {
      scribbler_set_led(LEFT, GREEN);
    } else {
      scribbler_set_led(LEFT, RED);
    }
    if ((sample_right > LINE_LIFT) && (sample_right <= black_trip)) {
      scribbler_set_led(RIGHT, GREEN);
    } else {
      scribbler_set_led(RIGHT, RED);
    }
    scribbler_rundemos_periodic(self);
  }
}

void scribbler_rundemos_line_follow(scribbler_rundemos *self)
{
  int32_t	search_cnt, rotate_deg, line_now, line_last, line_last_detect, mot_right_now, mot_right_target, mot_left_now, mot_left_target, ramp, black_trip, next_cnt;
  /* 
      
   */
  // Line Follow Behavior
  // Finger Code X0X / 6 Button Presses
  //
  // The line follow programs attempts to follow a black line on a white
  // background. For best performance, a line width of a 5/8 - 3/4"
  // (15 to 20mm) is recommended.  The line can be drawn with a black marker
  // on white paper or sample printed lines are available for download from
  // Parallax's website.  Use the Line Sensor Test Program (5 button presses)
  // to check surface compatibility.
  //
  // The sensitivity of the line sensors can be modfied if the scribbler has trouble
  // following a particular line.  To reduce the sensitivity, hold the scribbler in
  // air while starting the demo with the finger selection method or by
  // pressing the blue switch 6 times. Spin the small rear idler wheel 
  // until the center LED blinks green and then place the scribbler on the track.
  // Once the track is detect, the scribbler will start line following.  It is only
  // necessary to spin the idler wheel if your scribbler has trouble following a
  // particular line.  The default setting should work in most cases. 
  if (SONG_ENABLE) {
    scribbler_music_play_song(&self->music, EXCLAIM, 1500);
  }
  scribbler_set_leds(RED, OFF, RED, NO_CHANGE);
  // Wait for the user to put the scribbler on the track before starting
  if (scribbler_rundemos_lift_wait(self)) {
    black_trip = LINE_TRIP_ALT;
  } else {
    black_trip = LINE_TRIP;
  }
  scribbler_set_led(CENTER, OFF);
  // Initialize variables & state machine
  line_last = line_now = line_last_detect = LINE_SENSOR_NONE;
  mot_right_now = mot_right_target = 0;
  mot_left_now = mot_left_target = 0;
  search_cnt = 0;
  scribbler_rundemos_set_state(self, LINE_STATE_INIT);
  if (SONG_ENABLE) {
    scribbler_music_play_song(&self->music, ENTERTAINER, 3000);
  }
  // Next counter value to wait for                        
  next_cnt = CNT;
  while (1) {
    // Create a periodic loop
    waitcnt((next_cnt = next_cnt + (CLKFREQ / LINE_LOOP_FREQ)));
    // Sample the line sensors  
    if (!(scribbler_line_sensor(LEFT, black_trip))) {
      if (!(scribbler_line_sensor(RIGHT, black_trip))) {
        // Both lines detected
        line_last_detect = line_now = LINE_SENSOR_BOTH;
      } else {
        // Left line detected
        line_last_detect = line_now = LINE_SENSOR_LEFT;
      }
    } else {
      if (!(scribbler_line_sensor(RIGHT, black_trip))) {
        // Right line detected
        line_last_detect = line_now = LINE_SENSOR_RIGHT;
      } else {
        // No lines detected
        line_now = LINE_SENSOR_NONE;
      }
    }
    // Preempt normal state flow if a line is detected
    if (line_now == LINE_SENSOR_BOTH) {
    scribbler_rundemos_set_state(self, LINE_STATE_BOTH);
    } else if (line_now == LINE_SENSOR_LEFT) {
    scribbler_rundemos_set_state(self, LINE_STATE_LEFT);
    } else if (line_now == LINE_SENSOR_RIGHT) {
    scribbler_rundemos_set_state(self, LINE_STATE_RIGHT);
    }
    if (self->state_current == LINE_STATE_INIT) {
    // Line following state machine
    // Initial start up state
    scribbler_rundemos_set_state(self, LINE_STATE_LOST_CCW);
    } else if (self->state_current == LINE_STATE_LEFT) {
    // Left Detect - Arc Left
    search_cnt = 0;
    ramp = -1;
    scribbler_set_leds(GREEN, OFF, OFF, NO_CHANGE);
    mot_left_target = LINE_MILD_ARC_SLOW;
    mot_right_target = LINE_MILD_ARC_FAST;
    if (line_now == LINE_SENSOR_NONE) {
      scribbler_rundemos_set_state(self, LINE_STATE_MISS);
    }
    } else if (self->state_current == LINE_STATE_RIGHT) {
    // Right Detect - Arc Right
    search_cnt = 0;
    ramp = -1;
    scribbler_set_leds(OFF, OFF, GREEN, NO_CHANGE);
    mot_left_target = LINE_MILD_ARC_FAST;
    mot_right_target = LINE_MILD_ARC_SLOW;
    if (line_now == LINE_SENSOR_NONE) {
      scribbler_rundemos_set_state(self, LINE_STATE_MISS);
    }
    } else if (self->state_current == LINE_STATE_BOTH) {
    // Both Detect - Drive Straight
    search_cnt = 0;
    ramp = -1;
    scribbler_set_leds(GREEN, OFF, GREEN, NO_CHANGE);
    mot_left_target = mot_right_target = LINE_FOR_VEL;
    if (line_now == LINE_SENSOR_NONE) {
      scribbler_rundemos_set_state(self, LINE_STATE_MISS);
    }
    } else if (self->state_current == LINE_STATE_MISS) {
    if (line_last_detect == LINE_SENSOR_NONE) {
    // Select a search method based
    // on last detected line side.
    scribbler_rundemos_set_state(self, LINE_STATE_LOST_CCW);
    } else if (line_last_detect == LINE_SENSOR_LEFT) {
    scribbler_rundemos_set_state(self, LINE_STATE_SEARCH_LEFT);
    } else if (line_last_detect == LINE_SENSOR_RIGHT) {
    scribbler_rundemos_set_state(self, LINE_STATE_SEARCH_RIGHT);
    } else if (line_last_detect == LINE_SENSOR_BOTH) {
    scribbler_rundemos_set_state(self, LINE_STATE_LOST_CW);
    }
    } else if (self->state_current == LINE_STATE_SEARCH_LEFT) {
    // Search for line by arcing                   
    // to the left.
    ramp = -1;
    if (scribbler_rundemos_state_new(self)) {
      mot_left_target = LINE_HARD_ARC_SLOW;
      mot_right_target = LINE_HARD_ARC_FAST;
      scribbler_set_leds(YELLOW, OFF, OFF, NO_CHANGE);
    } else {
      if (search_cnt > LINE_SEARCH_MAX) {
        // Arcing didn't work
        // try rotating in place.
        scribbler_rundemos_set_state(self, LINE_STATE_LOST_CCW);
      }
    }
    } else if (self->state_current == LINE_STATE_SEARCH_RIGHT) {
    ramp = -1;
    if (scribbler_rundemos_state_new(self)) {
      scribbler_set_leds(OFF, OFF, YELLOW, NO_CHANGE);
      mot_left_target = LINE_HARD_ARC_FAST;
      mot_right_target = LINE_HARD_ARC_SLOW;
    } else {
      if (search_cnt > LINE_SEARCH_MAX) {
        scribbler_rundemos_set_state(self, LINE_STATE_LOST_CW);
      }
    }
    } else if (self->state_current == LINE_STATE_LOST_CW) {
    // Search by rotating
    mot_left_now = mot_right_now = 0;
    ramp = 0;
    if (scribbler_rundemos_state_new(self)) {
      // in place clockwise.
      scribbler_set_leds(OFF, OFF, RED, NO_CHANGE);
      scribbler_set_speed(LINE_ROT_SPD);
      if (self->state_previous != LINE_STATE_LOST_CCW) {
        // First rotate in place attempt
        rotate_deg = LINE_ROT_DEG;
        scribbler_turn_deg_now((-rotate_deg));
      } else {
        if (rotate_deg < 0x78) {
          // Increase rotation angle
          rotate_deg = rotate_deg + LINE_ROT_DEG;
          scribbler_turn_deg_now((-rotate_deg));
        } else {
          // Rotate failed, try backing up
          // a short distance.
          scribbler_rundemos_set_state(self, LINE_STATE_LOST_CENTER);
        }
      }
    } else {
      if (!(scribbler_moving())) {
        // Change rotation direction
        scribbler_rundemos_set_state(self, LINE_STATE_LOST_CCW);
      }
    }
    } else if (self->state_current == LINE_STATE_LOST_CCW) {
    // Search for by rotating
    // in place counterclockwise
    mot_left_now = mot_right_now = 0;
    ramp = 0;
    if (scribbler_rundemos_state_new(self)) {
      scribbler_set_leds(RED, OFF, OFF, NO_CHANGE);
      scribbler_set_speed(LINE_ROT_SPD);
      if (self->state_previous != LINE_STATE_LOST_CW) {
        rotate_deg = LINE_ROT_DEG;
        scribbler_turn_deg_now(rotate_deg);
      } else {
        if (rotate_deg < 0x78) {
          rotate_deg = rotate_deg + LINE_ROT_DEG;
          scribbler_turn_deg_now(rotate_deg);
        } else {
          scribbler_rundemos_set_state(self, LINE_STATE_LOST_CENTER);
        }
      }
    } else {
      if (!(scribbler_moving())) {
        scribbler_rundemos_set_state(self, LINE_STATE_LOST_CW);
      }
    }
    } else if (self->state_current == LINE_STATE_LOST_CENTER) {
    // Rotate to the center position
    // and then back up.
    ramp = 0;
    if (scribbler_rundemos_state_new(self)) {
      scribbler_set_leds(OFF, RED, OFF, NO_CHANGE);
      rotate_deg = rotate_deg / 2;
      if (self->state_previous == LINE_STATE_LOST_CCW) {
        scribbler_turn_deg_now(rotate_deg);
      } else {
        scribbler_turn_deg_now((-rotate_deg));
      }
    } else {
      if (!(scribbler_moving())) {
        scribbler_rundemos_set_state(self, LINE_STATE_LOST_REV);
      }
    }
    } else if (self->state_current == LINE_STATE_LOST_REV) {
    // Back up straight and then restart
    ramp = 0;
    if (scribbler_rundemos_state_new(self)) {
      // rotate in place search.
      scribbler_set_leds(OFF, RED, OFF, NO_CHANGE);
      scribbler_move_now((-160), (-160), 1500, 12, 0);
    } else {
      if (!(scribbler_moving())) {
        // Start rotate in place search again
        // once move is complete.
        scribbler_rundemos_set_state(self, LINE_STATE_LOST_CW);
      }
    }
    }
    if (ramp == -1) {
      // Ramp motors speeds
      if (mot_left_now > mot_left_target) {
        mot_left_now = Max__((mot_left_now - LINE_RAMP_STEP), mot_left_target);
      } else {
        mot_left_now = Min__((mot_left_now + LINE_RAMP_STEP), mot_left_target);
      }
      if (mot_right_now > mot_right_target) {
        mot_right_now = Max__((mot_right_now - LINE_RAMP_STEP), mot_right_target);
      } else {
        mot_right_now = Min__((mot_right_now + LINE_RAMP_STEP), mot_right_target);
      }
      scribbler_wheels_now(mot_left_now, mot_right_now, 0);
      if ((mot_right_now == mot_right_target) && (mot_left_now == mot_left_target)) {
        // motor ramp complete
        ramp = 0;
      }
    }
    // Save the previous line sample
    line_last = line_now;
    // Increment the search counter
    search_cnt = search_cnt + 1;
  }
}

void scribbler_rundemos_scribble(scribbler_rundemos *self)
{
  int32_t	_idx__0006;
  // Finger Code XX0 / 7 Button Presses
  // Draw a Figure Eight and a Square Shape using the marker port.
  if (SONG_ENABLE) {
    scribbler_music_play_song(&self->music, EXCLAIM, 1500);
  }
  scribbler_set_speed(5);
  scribbler_here_is(0, 0);
  scribbler_heading_is_deg(0);
  // Draw a figure 8
  scribbler_begin_path();
  // Top loop of 8
  scribbler_arc_by(SCRIB_EIGHT_RAD, (-SCRIB_EIGHT_RAD), SCRIB_EIGHT_RAD);
  scribbler_arc_by(SCRIB_EIGHT_RAD, SCRIB_EIGHT_RAD, SCRIB_EIGHT_RAD);
  scribbler_arc_by((-SCRIB_EIGHT_RAD), SCRIB_EIGHT_RAD, SCRIB_EIGHT_RAD);
  scribbler_arc_by((-SCRIB_EIGHT_RAD), (-SCRIB_EIGHT_RAD), SCRIB_EIGHT_RAD);
  // Bottom loop of 8
  scribbler_arc_by((-SCRIB_EIGHT_RAD), (-SCRIB_EIGHT_RAD), (-SCRIB_EIGHT_RAD));
  scribbler_arc_by((-SCRIB_EIGHT_RAD), SCRIB_EIGHT_RAD, (-SCRIB_EIGHT_RAD));
  scribbler_arc_by(SCRIB_EIGHT_RAD, SCRIB_EIGHT_RAD, (-SCRIB_EIGHT_RAD));
  scribbler_arc_by(SCRIB_EIGHT_RAD, (-SCRIB_EIGHT_RAD), (-SCRIB_EIGHT_RAD));
  scribbler_end_path();
  scribbler_wait_stop();
  scribbler_music_play_note(&self->music, QURT, G3, 0);
  // Pause between drawings
  scribbler_delay_tenths(&self->scribbler, 60);
  scribbler_here_is(0, 0);
  scribbler_heading_is_deg(0);
  // Draw a square
  scribbler_begin_path();
  scribbler_go_forward(SCRIB_SQR_LEN);
  for(_idx__0006 = 0; _idx__0006 < 3; _idx__0006++) {
    scribbler_go_right(SCRIB_SQR_LEN);
  }
  scribbler_end_path();
  scribbler_wait_stop();
  scribbler_music_play_song(&self->music, LAC, 1500);
  scribbler_rundemos_periodic_init(self);
  while (1) {
    scribbler_rundemos_periodic(self);
  }
}

static void scribbler_rundemos_set_state(scribbler_rundemos *self, int32_t state_set)
{
  // Set a new state & store the previous state 
  if (self->state_current != state_set) {
    // Set the state changed flag
    self->state_changed = -1;
  }
  // Store the previous state
  self->state_previous = self->state_current;
  self->state_current = state_set;
}

static int32_t scribbler_rundemos_state_new(scribbler_rundemos *self)
{
  int32_t	_tmp__0007;
  // Check if the state has been changed.
  // Cleared when called 
  return ( ( (_tmp__0007 = self->state_changed), (self->state_changed = 0) ), _tmp__0007 );
}

static void scribbler_rundemos_periodic_init(scribbler_rundemos *self)
{
  // Initializes the periodic timer & return after sampling the obstacle sensors
  // Sample the right obstalce sensor now
  self->obs_sample_right = scribbler_obstacle(&self->scribbler, RIGHT, OBS_THLD);
  self->periodic_next_cnt = (CLKFREQ / PERIODIC_FREQ) + CNT;
  self->obs_sample_side = LEFT;
  // Pause, sample the left and then return                                   
  scribbler_rundemos_periodic(self);
}

static void scribbler_rundemos_periodic(scribbler_rundemos *self)
{
  // Pause for a fixed duration since the last called.
  // Use to create a repeating function at the max obstacle sensor sample rate
  // Samples the IR receivers, checks the battery voltage and for motor overcurrents if there is time available.
  if (self->obs_sample_side == RIGHT) {
    // alternate sampling the right and left IR sensors                                
    self->obs_sample_right = scribbler_obstacle(&self->scribbler, RIGHT, OBS_THLD);
    self->obs_sample_side = LEFT;
  } else {
    self->obs_sample_left = scribbler_obstacle(&self->scribbler, LEFT, OBS_THLD);
    self->obs_sample_side = RIGHT;
  }
  if ((self->periodic_next_cnt - (CLKFREQ / 100)) > CNT) {
    // Check the battery voltage & motor driver OC state
    // if there's time.
    scribbler_rundemos_battery_check(self);
    scribbler_rundemos_oc_check(self);
  }
  if (self->periodic_next_cnt > CNT) {
    // Check if the counter has already passed the target                                         
    waitcnt(self->periodic_next_cnt);
  }
  // Calculate the next counter value  
  self->periodic_next_cnt = (CLKFREQ / PERIODIC_FREQ) + CNT;
}

int32_t scribbler_rundemos_obs_sampled(scribbler_rundemos *self, int32_t side)
{
  int32_t result = 0;
  // Returns the sampled obstacle sensor reading for a given side.
  // The sensor is sampled with periodic.
  if (side == RIGHT) {
    result = self->obs_sample_right;
  } else {
    result = self->obs_sample_left;
  }
  return result;
}

void scribbler_rundemos_oc_check(scribbler_rundemos *self)
{
  // Check for a hardware motor driver over current condition
  // An OC condition is indicated by blinking Red LED's
  // and the speaker beeping every 10 seconds.
  if (scribbler_get_adc_results(ADC_IMOT) > MOTOR_OC_TRIP) {
    scribbler_start(&self->scribbler);
    scribbler_start_tones(&self->scribbler);
    scribbler_set_leds(BLINK_RED, BLINK_RED, BLINK_RED, OFF);
    while (1) {
      scribbler_beep();
      scribbler_delay_tenths(&self->scribbler, 100);
    }
  }
}

int32_t scribbler_rundemos_battery_check(scribbler_rundemos *self)
{
  int32_t sample = 0;
  // Set the power LED corresponding to the battery voltage level
  sample = scribbler_get_adc_results(ADC_VBAT);
  if (sample < self->battery_min) {
    // Save the lowest battery
    // voltage detected
    self->battery_min = sample;
  }
  if (scribbler_get_model_s2()) {
    if (self->battery_min > S2_BATTERY_LOW_TRIP) {
      // Originial S2 Hardware
      scribbler_set_led(POWER, BLUE);
    } else {
      if (self->battery_min > S2_BATTERY_DEAD_TRIP) {
        scribbler_set_led(POWER, DIM_BLUE);
      } else {
        scribbler_set_led(POWER, BLINK_BLUE);
      }
    }
  } else {
    // S3 Hardware
    if ((scribbler_get_usb_powered()) || (self->battery_min > S3_BATTERY_LOW_TRIP)) {
      scribbler_set_led(POWER, BLUE);
    } else {
      if (self->battery_min > S3_BATTERY_DEAD_TRIP) {
        scribbler_set_led(POWER, DIM_BLUE);
      } else {
        if (self->battery_min > S3_BATTERY_OFF_TRIP) {
          scribbler_set_led(POWER, BLINK_BLUE);
        } else {
          // Play Taps and then shut off
          scribbler_stop_now();
          scribbler_music_play_song(&self->music, TAPS, 1000);
          scribbler_set_leds(DIM_GREEN, DIM_GREEN, DIM_GREEN, BLUE);
          scribbler_wait_sync(1);
          scribbler_set_leds(OFF, DIM_GREEN, DIM_GREEN, BLUE);
          scribbler_wait_sync(2);
          scribbler_set_leds(OFF, OFF, DIM_GREEN, BLUE);
          scribbler_wait_sync(3);
          scribbler_set_leds(OFF, OFF, OFF, DIM_BLUE);
          scribbler_wait_sync(4);
          scribbler_set_leds(OFF, OFF, OFF, OFF);
          scribbler_set_power_off();
        }
      }
    }
  }
  return sample;
}

/* 
+------------------------------------------------------------------------------------------------------------------------------+
|                                                   TERMS OF USE: MIT License                                                  | 
+------------------------------------------------------------------------------------------------------------------------------+
|Permission is hereby granted, free of charge, to any person obtaining a copy of this software and associated documentation    | 
|files (the "Software"), to deal in the Software without restriction, including without limitation the rights to use, copy,    |
|modify, merge, publish, distribute, sublicense, and/or sell copies of the Software, and to permit persons to whom the Software|
|is furnished to do so, subject to the following conditions:                                                                   |
|                                                                                                                              |
|The above copyright notice and this permission notice shall be included in all copies or substantial portions of the Software.|
|                                                                                                                              |
|THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR IMPLIED, INCLUDING BUT NOT LIMITED TO THE          |
|WARRANTIES OF MERCHANTABILITY, FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE AUTHORS OR         |
|COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE,   |
|ARISING FROM, OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN THE SOFTWARE.                         |
+------------------------------------------------------------------------------------------------------------------------------+
 */
